package com.ruoyi.generator.service;

import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.generator.domain.Template;
import com.ruoyi.generator.domain.TemplateFile;
import com.ruoyi.generator.mapper.TemplateMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 代码模版Service业务层处理
 *
 * @author ruoyi
 * @date 2023-11-24
 */
@Service
public class TemplateServiceImpl implements ITemplateService {
    @Autowired
    private TemplateMapper templateMapper;

    @Autowired
    private ITemplateFileService templateFileService;

    /**
     * 查询代码模版
     *
     * @param templateId 代码模版主键
     * @return 代码模版
     */
    @Override
    public Template selectTemplateByTemplateId(Long templateId) {
        Template template = templateMapper.selectTemplateByTemplateId(templateId);
        if (template != null) {
            template.setTemplateFiles(templateFileService.selectTemplateFilesByTemplateId(templateId));
        }
        return template;
    }

    /**
     * 查询代码模版列表
     *
     * @param template 代码模版
     * @return 代码模版
     */
    @Override
    public List<Template> selectTemplateList(Template template) {
        List<Template> templates = templateMapper.selectTemplateList(template);
        return templates;
    }

    /**
     * 新增代码模版
     *
     * @param template 代码模版
     * @return 结果
     */
    @Override
    @Transactional
    public int insertTemplate(Template template) {
        template.setCreateBy(SecurityUtils.getUsername());
        template.setCreateTime(DateUtils.getNowDate());
        int rows = templateMapper.insertTemplate(template);
        insertTemplateFiles(template);
        return rows;
    }

    /**
     * 修改代码模版
     *
     * @param template 代码模版
     * @return 结果
     */
    @Override
    @Transactional
    public int updateTemplate(Template template) {
        template.setUpdateBy(SecurityUtils.getUsername());
        template.setUpdateTime(DateUtils.getNowDate());
        templateFileService.deleteTemplateFilesByTemplateId(template.getTemplateId());
        insertTemplateFiles(template);
        return templateMapper.updateTemplate(template);
    }

    /**
     * 批量删除代码模版
     *
     * @param templateIds 需要删除的代码模版主键
     * @return 结果
     */
    @Override
    @Transactional
    public int deleteTemplateByTemplateIds(Long[] templateIds) {
        for (Long templateId : templateIds) {
            templateFileService.deleteTemplateFilesByTemplateId(templateId);
        }
        return templateMapper.deleteTemplateByTemplateIds(templateIds);
    }

    /**
     * 删除代码模版信息
     *
     * @param templateId 代码模版主键
     * @return 结果
     */
    @Override
    @Transactional
    public int deleteTemplateByTemplateId(Long templateId) {
        templateFileService.deleteTemplateFilesByTemplateId(templateId);
        return templateMapper.deleteTemplateByTemplateId(templateId);
    }

    /**
     * 新增代码模板文件信息
     *
     * @param template 代码模版对象
     */
    public void insertTemplateFiles(Template template) {
        List<TemplateFile> templateFiles = template.getTemplateFiles();
        Long templateId = template.getTemplateId();
        if (StringUtils.isNotNull(templateFiles)) {
            for (TemplateFile templateFile : templateFiles) {
                templateFile.setTemplateId(templateId);
                templateFile.setCreateBy(SecurityUtils.getUsername());
                templateFileService.insertTemplateFile(templateFile);
            }
        }
    }

    /**
     * 修改代码模版状态
     *
     * @param template 代码模版
     */
    @Override
    public int updateTemplateStatus(Template template) { // Changed parameter to Template object
        template.setUpdateBy(SecurityUtils.getUsername());
        template.setUpdateTime(DateUtils.getNowDate());
        return templateMapper.updateTemplate(template);
    }

    @Override
    public String selectActiveTemplate() {
        List<Template> list = templateMapper.selectActiveTemplate();
        if (list.size() > 0) {
            return list.get(0).getTemplatePath();

        }
        return null;
    }

    @Override
    public List<Template> selectAllTemplates() {
        Template template = new Template();
        return templateMapper.selectTemplateList(template);
    }
}
